#!/bin/bash
clear
echo "######################################################################"
echo "# ViSAS 2.21 - professional - INSTALLATION                           #"
echo "######################################################################"
echo ""
echo "################"
echo "#STEP 1 - CHECK#"
echo "################"
echo ""
echo "Checking installation."
echo ""
echo "[PRESS ENTER]"
read eingabe
touch /var/log/visas/visas-install 2>&1
install_ok="y"
echo "checking installed packages ..."

./check_rpms
if test "`cat ./tmp`" = "n"; then install_ok='n'; fi;
rm tmp
install_ok="y";

echo "";
if [ ! -e /etc/httpd/httpd.conf.orig ]; then
  install_ok='n'
  echo "Could not find /etc/httpd/httpd.conf.orig";
fi
if [ ! -e /etc/httpd/httpd.visas.orig ]; then
  install_ok='n'
  echo "Could not find /etc/httpd/httpd.visas.orig";
fi

echo ""
echo ""
sleep 2
if test "$install_ok" = "y" ; then
 echo "ViSAS can be installed!"
else
 echo "ViSAS SHOULD NOT BE INSTALLED !!"
 echo "Please try to solve these problems first!"
 echo "Please make sure that you have installed the systempack for your distribution!"
fi
sleep 1
echo ""
echo "Start installation now?"
echo "(Typing y you accept the contents of the files LIZENZ and WARNUNG!)"
echo "[y/n]"
read eingabe
if [ "$eingabe" != 'y' ]; then
  echo "Installation aborted!"
  exit 0
fi



clear
echo "######################################################################"
echo "# ViSAS 2.21 - professional - INSTALLATION                           #"
echo "######################################################################"
echo ""
echo "##################################################"
echo "#STEP 2 - VISAS Configuration		       #" 
echo "##################################################"
echo ""
echo "[PRESS ENTER]"
read eingabe
confirm="N"
while test "$confirm" != "Y" -a "$confirm" != "y"
do
echo ""
echo "Please enter the hostname of your server."
echo "This domain is for administration only!"
echo "Domain (e.g. admin.mycompany.com) of the server?"
read server_hostname
echo ""
echo "Serveradministrator's email-address?"
read admin_email
echo ""
echo "Verifying inputs:"
echo "Hostname: $server_hostname"
echo "Email: $admin_email"
echo ""
echo "correct? (Y/N)?"
read confirm
done
echo "$server_hostname" > tmp
server_hostname=$(cat tmp)
echo ""

echo "installing ViSAS-data ..."
gunzip <  visas-db.tar.gz | tar --directory="/var/lib/mysql/" -x
chgrp mysql /var/lib/mysql/visas >> /var/log/visas/visas-install 2>&1
chgrp mysql /var/lib/mysql/mysql >> /var/log/visas/visas-install 2>&1

mkdir /usr/local/visas/ >> /var/log/visas/visas-install 2>&1
mkdir /usr/local/visas/public_html >> /var/log/visas/visas-install 2>&1
mkdir /usr/local/visas/public_html/cgi-bin/ >> /var/log/visas/visas-install 2>&1
mkdir /usr/local/visas/etc/ >> /var/log/visas/visas-install 2>&1
echo "" > /usr/local/visas/etc/subdomains.conf

cp -a ./visas /usr/local/ >> /var/log/visas/visas-install 2>&1
sed s/NEW_SERVER_HOSTNAME/$server_hostname/g ./visas/etc/visas.conf | sed s/NEW_ADMIN_EMAIL/$admin_email/g > /usr/local/visas/etc/visas.conf

echo "resetting ViSAS rights..."
./fix_visas_rights.sh >> /var/log/visas/visas-install 2>&1

cp ./etc/ViSAS-release /etc/ >> /var/log/visas/visas-install 2>&1
chmod 600 /etc/ViSAS-release >> /var/log/visas/visas-install 2>&1
chown vpopmail:visas /etc/ViSAS-release >> /var/log/visas/visas-install 2>&1

echo "creating home directories ..."
cp -dpR home/* /home/ >> /var/log/visas/visas-install 2>&1

echo "creating httpd.conf ..."
sed s/NEW_SERVER_HOSTNAME/$server_hostname/g /etc/httpd/httpd.conf.orig | sed s/NEW_ADMIN_EMAIL/$admin_email/g > /etc/httpd/httpd.conf
sed s/NEW_SERVER_HOSTNAME/$server_hostname/g /etc/httpd/httpd.visas.orig | sed s/NEW_ADMIN_EMAIL/$admin_email/g > /etc/httpd/httpd.visas
rm /etc/httpd/httpd.conf.orig >> /var/log/visas/visas-install 2>&1
rm /etc/httpd/httpd.visas.orig >> /var/log/visas/visas-install 2>&1

chown vpopmail:visas /etc/httpd/httpd.conf >> /var/log/visas/visas-install 2>&1
chown vpopmail:visas /etc/httpd/httpd.visas >> /var/log/visas/visas-install 2>&1

echo "creating QMail conf ..."
newhostname=$(grep 'SERVERHOSTNAME=' /usr/local/visas/etc/visas.conf | sed s/SERVERHOSTNAME=//)
replace "d-ip.de" "$newhostname" -- /var/qmail/control/defaultdomain >> /var/log/visas/visas-install 2>&1
replace "i3home.d-ip.de" "$newhostname" -- /var/qmail/control/locals >> /var/log/visas/visas-install 2>&1
replace "i3home.d-ip.de" "$newhostname" -- /var/qmail/control/me >> /var/log/visas/visas-install 2>&1
replace "d-ip.de" "$newhostname" -- /var/qmail/control/plusdomain >> /var/log/visas/visas-install 2>&1
replace "i3home.d-ip.de" "$newhostname" -- /var/qmail/control/rcpthosts >> /var/log/visas/visas-install 2>&1
replace "i3home.d-ip.de" "$newhostname" -- /var/qmail/control/virtualdomains >> /var/log/visas/visas-install 2>&1

chmod 600 /usr/local/apache/conf/httpd.conf >> /var/log/visas/visas-install 2>&1
chmod 600 /usr/local/apache/conf/httpd.visas >> /var/log/visas/visas-install 2>&1
touch /var/log/visas/visasd.log >> /var/log/visas/visas-install 2>&1
chmod 600 /var/log/visas/visasd.log >> /var/log/visas/visas-install 2>&1
rm tmp

if test -e "/etc/visas_apache_2"; then
 replace "APACHE_VERSION=1" "APACHE_VERSION=2" -- /usr/local/visas/etc/visas.conf >> /var/log/visas/visas-install 2>&1
 rm /etc/visas_apache_2 >> /var/log/visas/visas-install 2>&1
fi

if test -e "/etc/SuSE-release"; then
 echo "running SuSEconfig ..."
 rm /etc/httpd/httpd.conf.SuSEconfig >> /var/log/visas/visas-install 2>&1
 SuSEconfig >> /var/log/visas/visas-install 2>&1
fi



clear
echo "######################################################################"
echo "# ViSAS 2.21 - professional - INSTALLATION                           #"
echo "######################################################################"
echo ""
echo "######################################################################"
echo "#STEP 3 - Restarting services                                        #"
echo "######################################################################"
echo ""
echo "[PRESS ENTER]"
read eingabe

echo "STARTING MySQL with /etc/init.d/mysql start"
/etc/init.d/mysql start
sleep 4
echo ""
echo "STARTING QMail (SMTP) with /etc/init.d/qmail start"
/etc/init.d/qmail start
sleep 3
echo ""
echo "STARTING Vpopmail (POP3) with /etc/init.d/pop3d start"
/etc/init.d/pop3d start
sleep 3
echo ""
echo "STARTING Courier-IMAP and POP3-SSL with /etc/init.d/imap start"
/etc/init.d/imap start
sleep 3
echo "" 
echo "STARTING ProFTPd (FTP) with /etc/init.d/proftpd start"
/etc/init.d/proftpd start
sleep 3
echo ""
echo "STARTING ViSAS APACHE (HTTP) with /etc/init.d/visas start"
/etc/init.d/visas start
sleep 3
echo ""
echo "STARTING APACHE (HTTP) with /etc/init.d/apache start"
/etc/init.d/apache start
sleep 3
echo ""
echo "STARTING SSHD (Secure Shell) with /etc/init.d/sshd start"
/etc/init.d/sshd start
sleep 3
echo ""
echo "STARTING BIND (Nameserver) with /etc/init.d/named start"
/etc/init.d/named start
sleep 3
echo ""
echo "RESTARTING CRON with /etc/init.d/cron restart"
/etc/init.d/cron restart
sleep 3
echo ""
echo ""
echo "[PRESS ENTER]"
read eingabe



clear
echo "######################################################################"
echo "# ViSAS 2.21 - professional - INSTALLATION FINISHED                  #"
echo "######################################################################"
echo ""
echo "How to start visas!"
echo "Call the system with http://$server_hostname/serveradminlevel/" 
echo "Loginname: visas"
echo "Password: visas"
echo "Change now the Passord under CONFIGURATION --> Basic configuration"
echo "You will find help under the Topic HELP --> First installation"
echo ""
echo "If you get any trouble give us a feeback." 
echo ""
echo "Have a lot of fun!"
echo ""
echo "Wie ViSAS gestartet wird!"
echo "Rufen Sie nun unter http://$server_hostname/serveradminlevel/"
echo "das System auf."
echo "Loginname: visas"
echo "Password: visas"
echo "ndern Sie nun als erstes das Password unter KONFIGURATION --> Grundkonfiguration"
echo "Die Grundkonfiguration ist unter HILFE --> Erstinstallation erlutert!"
echo ""
echo "Bei Problemen helfen wir Ihnen gerne bei der Installation."
echo "http://www.visas.de/support.php"
echo ""
echo "Viel Spass!"
